<template>

	<div class="flex">
		<div class="checkbox-container w-4 mr-2">
			<input v-if="!isNewItem" type="checkbox" class="cursor-pointer" :checked="item.checked" @change="$emit('toggled')" />
		</div>
		<div class="flex-1">
			<span v-if="!editing && !isNewItem" @click="startEditing()">{{ item.name }}</span>
			<input v-else ref="input" type="text" maxlength="30" class="border px-2" :class="{ 'p-2': isNewItem }" v-model="name" autofocus="true" @blur="save" @keyup.enter="save" @keyup.tab="save" />
		</div>
		<div v-if="!isNewItem">
			<button class="text-xs block -mt-1" @click="deleteItem">
				&cross;
			</button>
		</div>
	</div>

</template>

<script>
	
	export default {
		props: [
			'item',
		],
		emits: [
			'updated',
			'toggled'
		],
		computed: {
			isNewItem() { return !this.item; }
		},
		data() {
			return {
				editing: false,
				name: null
			}
		},
		methods: {
			startEditing() {
				this.name = this.item.name;
				this.editing = true;
				this.$nextTick(() => this.$refs.input.focus());
			},
			save() {
				this.$emit( 'updated', this.name );
				this.editing = false;
				if ( this.isNewItem ) this.name = '';
			},
			deleteItem() {
				this.$emit( 'updated', '' );
			}
		}
	};

</script>
